#include<bits/stdc++.h>

using namespace std;
long long T,N;
long long A[30007],B[30007],a,b,al,bl;
bool ne,oba1,oba2;
int main(){

    cin>>T;
    ne=false;
    oba1=false;
    oba2=false;
    for(int i=1;i<=T;i++){
        cin>>N;
        for(int i=1;i<=N;i++){
        cin>>A[i];
        if(A[i]!=0){
        a=A[i];
        al=i;
            }
        else{
            ne=true;
            oba1=true;
        }
    }
        for(int j=1;j<=N;j++){
            cin>>B[j];
        if(B[j]!=0){
        b=B[j];
        bl=j;
        }
        else{
            ne=true;
            oba2=true;
        }
    }
        if((b==a and abs(bl-al)%2==1) or (b!=a and abs(bl-al)%2==0) or ne==true or (oba1!=oba2)){
            cout<<"NE"<<endl;
        }
        else{
            cout<<"DA"<<endl;
        }
    }
return 0;
}